diff -u -p -r -N ../xkeyboard-config-1.5.orig//rules/HDR ./rules/HDR
--- ../xkeyboard-config-1.5.orig//rules/HDR	2010-12-14 14:39:56.000000000 +0100
+++ ./rules/HDR	2010-12-14 14:40:35.000000000 +0100
@@ -18,6 +18,7 @@
 ! layout[4]	variant[4]	=	symbols
 ! model		=	symbols
 ! model		layout		=	compat
+! model		layout		keycodes	=	symbols
 ! model		layout[1]	=	compat
 ! model		=	types
 ! layout	option	=	symbols
@@ -26,5 +27,6 @@
 ! layout[3]	option	=	symbols
 ! layout[4]	option	=	symbols
 ! option	=	symbols
+! option	layout	=	symbols
 ! option	=	compat
 ! option	=	types
diff -u -p -r -N ../xkeyboard-config-1.5.orig//rules/Makefile.am ./rules/Makefile.am
--- ../xkeyboard-config-1.5.orig//rules/Makefile.am	2010-12-14 14:39:56.000000000 +0100
+++ ./rules/Makefile.am	2010-12-14 14:41:23.000000000 +0100
@@ -38,6 +38,7 @@ HDR base.l4_s.part \
 HDR HDR HDR \
 HDR base.m_s.part \
 HDR base.ml_c.part \
+HDR base.mlk_s.part \
 HDR base.ml1_c.part \
 HDR base.m_t.part \
 HDR base.l1o_s.part \
@@ -45,6 +46,7 @@ HDR base.l2o_s.part \
 HDR base.l3o_s.part \
 HDR base.l4o_s.part \
 HDR base.o_s.part \
+HDR base.ol_s.part \
 HDR base.o_c.part \
 HDR base.o_t.part
 
@@ -66,6 +68,7 @@ HDR base.l4_s.part \
 HDR HDR HDR \
 HDR evdev.m_s.part \
 HDR base.ml_c.part \
+HDR base.mlk_s.part \
 HDR base.ml1_c.part \
 HDR base.m_t.part \
 HDR base.l1o_s.part \
@@ -73,6 +76,7 @@ HDR base.l2o_s.part \
 HDR base.l3o_s.part \
 HDR base.l4o_s.part \
 HDR base.o_s.part \
+HDR base.ol_s.part \
 HDR base.o_c.part \
 HDR base.o_t.part
 
@@ -99,6 +103,7 @@ HDR compat/base.l3v3_s.part \
 HDR compat/base.l4v4_s.part \
 HDR base.m_s.part \
 HDR base.ml_c.part \
+HDR base.mlk_s.part \
 HDR base.ml1_c.part \
 HDR base.m_t.part \
 HDR base.lo_s.part \
@@ -107,6 +112,7 @@ HDR base.l2o_s.part \
 HDR base.l3o_s.part \
 HDR base.l4o_s.part \
 HDR compat/base.o_s.part base.o_s.part \
+HDR base.ol_s.part \
 HDR base.o_c.part \
 HDR base.o_t.part
 
@@ -132,6 +138,7 @@ HDR compat/base.l3v3_s.part \
 HDR compat/base.l4v4_s.part \
 HDR evdev.m_s.part \
 HDR base.ml_c.part \
+HDR base.mlk_s.part \
 HDR base.ml1_c.part \
 HDR base.m_t.part \
 HDR base.lo_s.part \
@@ -140,6 +147,7 @@ HDR base.l2o_s.part \
 HDR base.l3o_s.part \
 HDR base.l4o_s.part \
 HDR compat/base.o_s.part base.o_s.part \
+HDR base.ol_s.part \
 HDR base.o_c.part \
 HDR base.o_t.part
 else
diff -u -p -r -N ../xkeyboard-config-1.5.orig//rules/Makefile.in ./rules/Makefile.in
--- ../xkeyboard-config-1.5.orig//rules/Makefile.in	2010-12-14 14:39:56.000000000 +0100
+++ ./rules/Makefile.in	2010-12-14 14:42:22.000000000 +0100
@@ -212,6 +212,7 @@ HDR base.l4_s.part \
 HDR HDR HDR \
 HDR base.m_s.part \
 HDR base.ml_c.part \
+HDR base.mlk_s.part \
 HDR base.ml1_c.part \
 HDR base.m_t.part \
 HDR base.l1o_s.part \
@@ -219,6 +220,7 @@ HDR base.l2o_s.part \
 HDR base.l3o_s.part \
 HDR base.l4o_s.part \
 HDR base.o_s.part \
+HDR base.ol_s.part \
 HDR base.o_c.part \
 HDR base.o_t.part
 
@@ -240,6 +242,7 @@ HDR base.l4_s.part \
 HDR HDR HDR \
 HDR evdev.m_s.part \
 HDR base.ml_c.part \
+HDR base.mlk_s.part \
 HDR base.ml1_c.part \
 HDR base.m_t.part \
 HDR base.l1o_s.part \
@@ -247,6 +250,7 @@ HDR base.l2o_s.part \
 HDR base.l3o_s.part \
 HDR base.l4o_s.part \
 HDR base.o_s.part \
+HDR base.ol_s.part \
 HDR base.o_c.part \
 HDR base.o_t.part
 
@@ -273,6 +277,7 @@ HDR base.o_t.part
 @USE_COMPAT_RULES_TRUE@HDR compat/base.l4v4_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.m_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.ml_c.part \
+@USE_COMPAT_RULES_TRUE@HDR base.mlk_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.ml1_c.part \
 @USE_COMPAT_RULES_TRUE@HDR base.m_t.part \
 @USE_COMPAT_RULES_TRUE@HDR base.lo_s.part \
@@ -281,6 +286,7 @@ HDR base.o_t.part
 @USE_COMPAT_RULES_TRUE@HDR base.l3o_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.l4o_s.part \
 @USE_COMPAT_RULES_TRUE@HDR compat/base.o_s.part base.o_s.part \
+@USE_COMPAT_RULES_TRUE@HDR base.ol_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.o_c.part \
 @USE_COMPAT_RULES_TRUE@HDR base.o_t.part
 
@@ -307,6 +313,7 @@ HDR base.o_t.part
 @USE_COMPAT_RULES_TRUE@HDR compat/base.l4v4_s.part \
 @USE_COMPAT_RULES_TRUE@HDR evdev.m_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.ml_c.part \
+@USE_COMPAT_RULES_TRUE@HDR base.mlk_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.ml1_c.part \
 @USE_COMPAT_RULES_TRUE@HDR base.m_t.part \
 @USE_COMPAT_RULES_TRUE@HDR base.lo_s.part \
@@ -315,6 +322,7 @@ HDR base.o_t.part
 @USE_COMPAT_RULES_TRUE@HDR base.l3o_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.l4o_s.part \
 @USE_COMPAT_RULES_TRUE@HDR compat/base.o_s.part base.o_s.part \
+@USE_COMPAT_RULES_TRUE@HDR base.ol_s.part \
 @USE_COMPAT_RULES_TRUE@HDR base.o_c.part \
 @USE_COMPAT_RULES_TRUE@HDR base.o_t.part
 
diff -u -p -r -N ../xkeyboard-config-1.5.orig//rules/base.mlk_s.part ./rules/base.mlk_s.part
--- ../xkeyboard-config-1.5.orig//rules/base.mlk_s.part	1970-01-01 01:00:00.000000000 +0100
+++ ./rules/base.mlk_s.part	2010-12-14 14:40:35.000000000 +0100
@@ -0,0 +1 @@
+$msmodels	jp	*	=	+inet(jp_fix)
diff -u -p -r -N ../xkeyboard-config-1.5.orig//rules/base.ol_s.part ./rules/base.ol_s.part
--- ../xkeyboard-config-1.5.orig//rules/base.ol_s.part	1970-01-01 01:00:00.000000000 +0100
+++ ./rules/base.ol_s.part	2010-12-14 14:40:35.000000000 +0100
@@ -0,0 +1 @@
+  inet:microsoftpro	jp	=	+inet(jp_fix)
diff -u -p -r -N ../xkeyboard-config-1.5.orig//symbols/inet ./symbols/inet
--- ../xkeyboard-config-1.5.orig//symbols/inet	2010-12-14 14:39:56.000000000 +0100
+++ ./symbols/inet	2010-12-14 14:40:35.000000000 +0100
@@ -83,6 +83,11 @@ xkb_symbols "media_acpi_common" {
     include "inet(acpi_common)"
 };
 
+partial hidden alphanumeric_keys
+xkb_symbols "jp_fix" {
+    key <I01>   {       [ Henkan ] }; 
+};
+
 // Evdev Standardized Keycodes
 partial alphanumeric_keys
 xkb_symbols "evdev" {
